PetState=PetState or {}
PetState.active=false;
PetState.interval=5;


function PetState:OnLoad(this)
    this:RegisterEvent("VARIABLES_LOADED");
end;

function PetState:OnUpdate(this, elapsedTime )
    if self.active==true then
        self.tremain=self.tremain-elapsedTime;
        if self.tremain <=0 then
            self.tremain=self.interval;
            PetState:SetState(this)
        end
    end
end;


function PetState:OnEvent(this, event, arg1, arg2 )
    if ( event == "VARIABLES_LOADED" ) then
        self.active=true;
        self.tremain=self.interval;
        PetState:SetState(this)
    end;
end;

function PetState:OnClick(this, key)
	local function feed(petindex)
		local loyal 	= GetPetItemAbility(petindex, "LOYAL");
		local food 		= GetPetItemAbility(petindex, "HUNGER");
		local training 	= GetPetItemAbility(petindex, "UNDERGO");
		
		local i,j
		local anzahl = GetPetFeedItem(-1)
		for i=1,anzahl do
			SetPetFeedItem(i)
			local name, texture, count = GetPetFeedFoodItem();
			if (name == TEXT('Sys204510_name')) then
				if (loyal < 100) then
					local schluck = 100-loyal
					if (schluck > count) then
						schluck = count
					end
					for j=1,schluck do
						FeedPet(petindex)
						loyal = loyal + 1
					end
				end
			elseif (name == TEXT('Sys204791_name')) then
				if (food <= 95) then
					local schluck = math.floor((100-food)/5)
					if (schluck > count) then
						schluck = count
					end
					for j=1,schluck do
						FeedPet(petindex)
						food = food + 5
						training = training + 1
					end
				end
			elseif (name == TEXT('Sys204925_name')) then
				if (food <= 90) then
					local schluck =  math.floor((100-food)/10)
					if (schluck > count) then
						schluck = count
					end
					for j=1,schluck do
						FeedPet(petindex)
						food = food + 10
					end
				end
			end
		end
		ClearPetFeedItem()
	end
	if IsCtrlKeyDown() then
		if (IsPetSummoned(1) == false) then
			feed(1)
			SummonPet(1)
		else
			ReturnPet(1)
		end
	elseif IsShiftKeyDown() then
		if(IsPetSummoned(2) == false) then
			feed(2)
			SummonPet(2)
		else
			ReturnPet(2)
		end
	else
		if(IsPetSummoned(3) == false) then
			feed(3)
			SummonPet(3)
		else
			ReturnPet(3)
		end
	end
end;

function PetState:MMTooltip(this)
    GameTooltip:ClearAllAnchors();
    GameTooltip:SetOwner(this, "ANCHOR_LEFT", 4, 0);
    GameTooltip:ClearLines();
    GameTooltip:SetText("");
    GameTooltip:AddLine("Shows the state of your pet");
    GameTooltip:AddLine(UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95);
    GameTooltip:Show();
end

function PetState:Echo(msg)
    DEFAULT_CHAT_FRAME:AddMessage(tostring(msg),0.8,0.8,0.8);
end

function PetState:SetState(this)
    if IsPetSummoned(3) then
        PetState_MinimapButton:GetNormalTexture():SetColor(0,1,0);
    elseif (IsPetSummoned(2)) or (IsPetSummoned(1)) or (IsPetSummoned(4)) or (IsPetSummoned(5)) or (IsPetSummoned(6)) then
        PetState_MinimapButton:GetNormalTexture():SetColor(0,0.75,1);
    else
        PetState_MinimapButton:GetNormalTexture():SetColor(0.75,0,0);
    end
end